EmailManager.Web/Models/LoanApplicationViewModel.cs
using EmailManager.Data.Models;
using System;
using System.ComponentModel.DataAnnotations;

namespace EmailManager.Web.Models
{
    public class LoanApplicationViewModel
    {
        public int Id { get; set; }

        public DateTime? LoanDecisionSetOn { get; set; }

        public ApplicationUser User { get; set; }

        public LoanApplicantViewModel LoanApplicant { get; set; }

        public LoanDecision LoanDecision { get; set; }

        public EmailViewModel Email { get; set; }
    }
}

EmailManager.Web/Controllers/LoanApplicationController.cs
using Crypteron.CipherObject;
using EmailManager.Data.Models;
using EmailManager.Services.Contracts;
using EmailManager.Web.Mappers.Contracts;
using EmailManager.Web.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace EmailManager.Web.Controllers
{
    public class LoanApplicationController : Controller
    {
        private readonly ILoanApplicationService loanApplicationService;
        private readonly ILoanApplicantService loanApplicantService;
        private readonly IViewModelMapper<LoanApplication, LoanApplicationViewModel> loanApplicationMapper;
        private readonly IViewModelMapper<ClientEmail, EmailViewModel> emailMapper;
        private readonly UserManager<ApplicationUser> _userManager;
        private readonly IEmailService emailService;

        public LoanApplicationController(ILoanApplicationService loanApplicationService, ILoanApplicantService loanApplicantService,
                                         IViewModelMapper<LoanApplication, LoanApplicationViewModel> loanApplicationMapper, 
                                         UserManager<ApplicationUser> userManager, IViewModelMapper<ClientEmail, EmailViewModel> emailMapper,
                                         IEmailService emailService)
        {
            this.loanApplicationService = loanApplicationService ?? throw new ArgumentNullException(nameof(loanApplicationService));
            this.loanApplicantService = loanApplicantService ?? throw new ArgumentNullException(nameof(loanApplicantService));
            this.loanApplicationMapper = loanApplicationMapper ?? throw new ArgumentNullException(nameof(loanApplicationMapper));
            this.emailMapper = emailMapper ?? throw new ArgumentNullException(nameof(emailMapper));
            this.emailService = emailService ?? throw new ArgumentNullException(nameof(emailService));
            _userManager = userManager;

        }

        [HttpGet]
        [Authorize]
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult AddLoanApplication()
        {
            return View();
        }

        [HttpPost]
        [Authorize]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddLoanApplication(LoanApplicationViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var loanApplicant = await this.loanApplicantService.AddLoanApplicantAsync(model.LoanApplicant.Name, model.LoanApplicant.PersonalNumber, 
                                                                                      model.LoanApplicant.PhoneNumber);

            var loanApplication = await this.loanApplicationService.AddLoanApplicationAsync(loanApplicant, model.Email.Id);

            return RedirectToAction("Index", "Home");
        }

        private Task<ApplicationUser> GetCurrentUserAsync() => _userManager.GetUserAsync(HttpContext.User);

        [HttpGet]
        public IActionResult Details(int id)
        {
            var email = this.emailService.GetEmail(id);
            var emailBodyContent = email.EmailBody.Content;
            var model = new EmailApplicationViewModel();
            //model.Email = this.emailMapper.MapFrom(email);
            //model.Email.EmailBodyContent = emailBodyContent.Unseal();

            var emailViewModel = this.emailMapper.MapFrom(email);
            var content = emailViewModel.EmailBodyContent;
            model.Email = emailViewModel;

            return PartialView("_AddLoanApplication", model);
        }

        [HttpPost]
        public IActionResult Details(EmailApplicationViewModel model)
        {
            var email = this.emailService.GetEmail(model.Email.Id);
            var loanApplication = email.LoanApplication;
            return PartialView("_AddLoanApplication", model);
        }


        [HttpPost]
        public async Task<IActionResult> ListNewEmails()
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            var start = Request.Form["start"].FirstOrDefault();
            var length = Request.Form["length"].FirstOrDefault();
            var searchValue = Request.Form["search[value]"].FirstOrDefault();

            int pageSize = length != null ? Convert.ToInt32(length) : 0;
            int skip = start != null ? Convert.ToInt32(start) : 0;

            int totalRecord = this.emailService.GetNewEmailsCount();
            var emails = await this.emailService.ListNewEmails(skip, pageSize, searchValue);


            var model = emails.Select(x => this.emailMapper.MapFrom(x)).ToList();

            var json = Json(new { draw = draw, recordsFiltered = totalRecord, recordsTotal = totalRecord, data = model });

            json.SerializerSettings = new Newtonsoft.Json.JsonSerializerSettings
            {
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
            };

            return json;
        }

    }
}

EmailManager.Web/Views/LoanApplication/AddLoanApplication.cshtml
@model EmailViewModel

@{
    ViewData["Title"] = "ListNewEmails";
}

<h2></h2>
<table id="table_id" class="display">
    <thead class="alert-success">
        <tr>
            <th>ID</th>
            <th>Subject</th>
            <th>ReceivedOn</th>
            <th>Sender</th>
            <th>Status Set Before</th>
            <th>Details</th>
        </tr>
    </thead>
</table>

<!-- Modal -->
<div class="modal fade" id="myModalNorm" tabindex="-1" role="dialog"
     aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <!-- Modal Body -->
            <div class="modal-body"></div>

            <div class="modal-footer"> </div>
        </div>
    </div>
</div>

@section Scripts

    {
    <link rel="stylesheet" type="text/css" href="~/lib/DataTables/datatables.css">
    <script type="text/javascript" language="javascript" src="~/lib/DataTables/datatables.js"></script>
    <script src="~/js/site.js"></script>
    <script type="text/javascript" class="init">

        var table = $('#table_id').DataTable({
            "ordering": false,
            "processing": true,
            "serverSide": true,
            "ajax": {
                "url": "@Url.Action("ListNewEmails", "LoanApplication")",
                "type": 'POST',
                "dataType": "JSON",
            },

            "columns": [
                { "data": "Id" },
                { "data": "Subject" },
                { "data": "ReceivedOn"},
                { "data": "MerchantEmail" },
                { "data": "CurrentStatusTimeSpan" },
                {
                    "render": function (data, type, email, meta) {
                        return '<button class="details" data-toggle="modal" data-target="#myModalNorm" data-emailid="' + email.Id + '">See more</button>';
                   }
                }
            ]
        });

        $('#myModalNorm').on('shown.bs.modal', function (e) {
            console.log(e);
            var $modal = $(this);
            $body = $modal.find(".modal-body");
            var emailId = $(e.relatedTarget).data('emailid');
            var url = "/LoanApplication/Details/" + emailId;
            $.get(url)
                .done(function (responseData) {
                    $body.html(responseData);
                    $('#Open').data('emailid', emailId);
                })
        })

        $(function () {
            $(document).on('click', '#Open', function (e) {
                e.preventDefault();
                var data = $('#add-loanapllication-form').serialize();
                var id = $(this).data('emailid');

                data += '&Email.Id=' + id;

                $.post("/LoanApplication/AddLoanApplication/", data, function (response) {
                    console.log(response);
                });
            });
        });
    </script>
}